/*******************************************************************************
* Copyright (c) 2001-2002 Rational Software Corporation. All rights reserved.  *
*                                                                              *
*                Product: Rational(R) Test RealTime                            *
*                                                                              *
*      Product Component: All                                                  *
*                                                                              *
*               Language: C / C++                                              *
*                                                                              *
*        Product version: 2002.05.01                                           *
*                                                                              *
* Target Deployment Port: clinuxgnu                                            *
*                         C Linux - Gnu 2.95.2                                 *
*                                                                              *
*                   File: products_model.h                                     *
*                         Studio-modifiable Settings (Parsed by Products.pl)   *
*                                                                              *
* Rational, the Rational logo are registered trademarks of                     *
* Rational Software Corporation.                                               *
*                                                                              *
* The placing of the copyright notices on Rational source code is not          *
* intended to mean that they are published works, but are included in the      *
* event of inadvertent publication. The source code of Rational contains       *
* trade secrets and other valuable confidential information of Rational        *
* Software Corporation. Rational Software Corporation and its licensors        *
* retain ownership to Rational Products in both source and object code         *
* format, and related documentation and all rights therein including           *
* copyrights, patents and trade secrets.                                       *
*                                                                              *
*                                                                              *
* U.S. Government Rights                                                       *
*                                                                              *
* Use, duplication, or disclosure by the U.S. Government is subject to         *
* restrictions set forth in the applicable Rational License Agreement          *
* and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS                   *
* 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,         *
* or FAR 52.227-14, as applicable.                                             *
*                                                                              *
* Unless otherwise agreed to in writing, use of Rational products is           *
* governed by the Rational Product License Agreement provided with             *
* the product.                                                                 *
*******************************************************************************/

/*******************************************************************************
* $Id: products_model.h,v 1.24 2001/11/12 11:59:50 attolcov Exp $
* $Descr: Studio-modifiable Settings (Parsed by Products.pl) $
*******************************************************************************/

#define ATL_WITHOUT_STUDIO


#define ATL_YES      1
#define ATL_NO       0

/* ATTENTION You have to instrument with the options -purifylt
   -quantifylt -trace and at least one coverage option */

#define USE_ATC ATL_YES
#define USE_ATT ATL_YES
#define USE_ATP ATL_YES
#define USE_ATQ ATL_YES

#ifndef ATL_WITHOUT_STUDIO

/* WARNING:
     @PRODUCT@ lines are updated by Perl script ! */

/* Use TestRT Unit Testing */
@PRODUCT@ USE_ATU ATL_YES|ATL_NO
/* Use TestRT System Testing */
@PRODUCT@ USE_ATS ATL_YES|ATL_NO
/* Use TestRT Object Testing */
@PRODUCT@ USE_ATO ATL_YES|ATL_NO
/* Use TestRT Contract Check */
@PRODUCT@ USE_ATK ATL_YES|ATL_NO
/* Use TestRT Coverage */
@PRODUCT@ USE_ATC ATL_YES|ATL_NO
/* Use TestRT Trace */
@PRODUCT@ USE_ATT ATL_YES|ATL_NO
/* Use TestRT PurifyLT */
@PRODUCT@ USE_ATP ATL_YES|ATL_NO
/* Use TestRT QuantifyLT */
@PRODUCT@ USE_ATQ ATL_YES|ATL_NO

#else /* ATL_WITHOUT_STUDIO */

#ifndef USE_ATU
#define USE_ATU ATL_NO
#endif
#ifndef USE_ATS
#define USE_ATS ATL_NO
#endif
#ifndef USE_ATO
#define USE_ATO ATL_NO
#endif
#ifndef USE_ATK
#define USE_ATK ATL_NO
#endif
#ifndef USE_ATC
#define USE_ATC ATL_NO
#endif
#ifndef USE_ATT
#define USE_ATT ATL_NO
#endif
#ifndef USE_ATP
#define USE_ATP ATL_NO
#endif
#ifndef USE_ATQ
#define USE_ATQ ATL_NO
#endif

#endif /* ATL_WITHOUT_STUDIO */


/*******************************************************************************
* TestRT Unit Testing:
*******************************************************************************/

#if USE_ATU

#ifndef ATL_WITHOUT_STUDIO
@ATU@ ATU_BREAK_ON_TEST_FAILED ATL_NO|ATL_YES
#else
#ifndef ATU_BREAK_ON_TEST_FAILED
/*! Calls a breakpoint function on an error if 1 */
#define ATU_BREAK_ON_TEST_FAILED ATL_NO
#endif
#endif

#endif


/*******************************************************************************
* TestRT System Testing:
*******************************************************************************/

#if USE_ATS

#ifndef ATL_WITHOUT_STUDIO
@ATS@ ATS_BUFFER_SIZE <number>
#else
#ifndef ATS_BUFFER_SIZE
/*! Size in bytes of buffer (used to store string vars and lines) */
#define ATS_BUFFER_SIZE 1024
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATS@ ATS_TAGTBUF_SIZE <number>
#else
#ifndef ATS_TAGTBUF_SIZE
/*! Maximum size in bytes of lines raised by testers */
#define ATS_TAGTBUF_SIZE 4096
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATS@ ATS_RT_BUFFER ATL_YES|ATL_NO
#else
#ifndef ATS_RT_BUFFER
/*! Use bufferized items */
#define ATS_RT_BUFFER ATL_NO
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATS@ ATS_DYNFLW ATL_YES|ATL_NO
#else
#ifndef ATS_DYNFLW
/*! Activates dynamic tracking */
#define ATS_DYNFLW ATL_NO
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATS@ ATS_INTERRECV_TIMEOUT <number>
#else
#ifndef ATS_INTERRECV_TIMEOUT
/*! Timeout for INTERRECV instruction */
#define ATS_INTERRECV_TIMEOUT 300
#endif
#endif

#endif


/*******************************************************************************
* TestRT Object Testing:
*******************************************************************************/

#if USE_ATO

#ifndef ATL_WITHOUT_STUDIO
@ATO@ ATO_BREAK_ON_CHECK_FAILED ATL_NO|ATL_YES
#else
#ifndef ATO_BREAK_ON_CHECK_FAILED
/*! Calls a breakpoint function on an error if 1 */
#define ATO_BREAK_ON_CHECK_FAILED ATL_NO
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATO@ ATO_DUMP_SUCCESS ATL_NO|ATL_YES
#else
#ifndef ATO_DUMP_SUCCESS
/*! Also dumps successful checks in traces */
#define ATO_DUMP_SUCCESS 1
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATO@ ATO_MAX_INSTANCES <number>
#else
#ifndef ATO_MAX_INSTANCES
/*! Size of instances stack */
#define ATO_MAX_INSTANCES 256
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATO@ ATO_PRINT_BUFFER_SIZE <number>
#else
#ifndef ATO_PRINT_BUFFER_SIZE
/* Size of PRINT buffer (0 means no buffering: PRINT arguments are displayed
 * on separate notes) */
#define ATO_PRINT_BUFFER_SIZE 512
#endif
#endif

#endif /* USE_ATO */

/*******************************************************************************
* TestRT Contract Check:
*******************************************************************************/

#if USE_ATK

#ifndef ATL_WITHOUT_STUDIO
@ATK@ ATK_BREAK_ON_ASSERT_FAILED ATL_NO|ATL_YES
#else
#ifndef ATK_BREAK_ON_ASSERT_FAILED
/*! Calls a breakpoint function on an error if 1 */
#define ATK_BREAK_ON_ASSERT_FAILED 0
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATK@ ATK_DUMP_SUCCESS ATL_NO|ATL_YES
#else
#ifndef ATK_DUMP_SUCCESS
/*! Also dumps successful assertions in traces */
#define ATK_DUMP_SUCCESS 0
#endif
#endif

#endif /* USE_ATK */


/*******************************************************************************
* TestRT Coverage:
*******************************************************************************/

#if USE_ATC

/* 0: pass mode,
 * 1: compact mode,
 * 2: count mode */
#ifndef ATL_WITHOUT_STUDIO
@ATC@ ATC_INFORMATION 0|1|2
#else
#ifndef ATC_INFORMATION
/* pass mode */
#define ATC_INFORMATION 0
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATC@ ATC_DUMP_DRIVER ATL_YES|ATL_NO
#else
#ifndef ATC_DUMP_DRIVER
/* Dump Driver use */
#define ATC_DUMP_DRIVER ATL_NO
#endif
#endif

#endif


/*******************************************************************************
* TestRT Trace:
*******************************************************************************/

#if USE_ATT

#ifndef ATL_WITHOUT_STUDIO
@ATT@ ATT_ON_THE_FLY ATL_YES|ATL_NO
#else
#ifndef ATT_ON_THE_FLY
/* trace on the fly (natives only) */
#define ATT_ON_THE_FLY ATL_YES
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATT@ ATT_ITEMS_MAX <number>
#else
#ifndef ATT_ITEMS_MAX
/* maximum number of buffered items */
#define ATT_ITEMS_MAX 0
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATT@ ATT_DUMP_FROM_BEGINNING ATL_YES|ATL_NO
#else
#ifndef ATT_DUMP_FROM_BEGINNING
/* trace from beginning: if ATL_YES, message dump starting, stopping and
   toggling and stack dump are not available */
#define ATT_DUMP_FROM_BEGINNING ATL_YES
#endif
#endif

/* action associated to signal handling */
#define ATT_SIGNAL_TOGGLE_DUMP 1
#define ATT_SIGNAL_DUMP_CALL_STACK 2

#ifndef ATL_WITHOUT_STUDIO
@ATT@ ATT_SIGNAL ATL_NO|ATT_SIGNAL_TOGGLE_DUMP|ATT_SIGNAL_DUMP_CALL_STACK
#else
#ifndef ATT_SIGNAL
/* possible values for ATT_SIGNAL:
   ATL_NO, ATT_SIGNAL_TOGGLE_DUMP or ATT_SIGNAL_DUMP_CALL_STACK */
#define ATT_SIGNAL ATL_NO
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATT@ ATT_COMPUTE_MAX_CALLING_LEVEL ATL_YES|ATL_NO
#else
#ifndef ATT_COMPUTE_MAX_CALLING_LEVEL
/* compute maximum calling level */
#define ATT_COMPUTE_MAX_CALLING_LEVEL ATL_NO
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATT@ ATT_TIMESTAMP ATL_YES|ATL_NO
#else
#ifndef ATT_TIMESTAMP
/* possible values for ATT_TIMESTAMP:
   ATL_NO or ATL_YES */
#define ATT_TIMESTAMP ATL_NO
#endif
#endif


/* multi-threaded applications only: */

#ifndef ATL_WITHOUT_STUDIO
@ATT@ ATT_THREAD_CREATION_NOTE ATL_YES|ATL_NO
#else
#ifndef ATT_THREAD_CREATION_NOTE
/* note must be shown each time a thread is created */
#define ATT_THREAD_CREATION_NOTE ATL_NO
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATT@ ATT_THREAD_SCHEDULE_NOTE ATL_YES|ATL_NO
#else
#ifndef ATT_THREAD_SCHEDULE_NOTE
/* note must be shown each time a thread is scheduled */
#define ATT_THREAD_SCHEDULE_NOTE ATL_NO
#endif
#endif

#endif


/*******************************************************************************
* TestRT PurifyLT:
*******************************************************************************/

#if USE_ATP

#ifndef ATL_WITHOUT_STUDIO
@ATP@ ATP_CALL_STACK_SIZE <number>
#else
#ifndef ATP_CALL_STACK_SIZE
/* how many call stack items in each memory block description */
#define ATP_CALL_STACK_SIZE 6
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATP@ ATP_REPORTS_FIU ATL_YES|ATL_NO
#else
#ifndef ATP_REPORTS_FIU
/* File In Use Reporting */
#define ATP_REPORTS_FIU ATL_NO
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATP@ ATP_REPORTS_FFM_FMWL ATL_YES|ATL_NO
#else
#ifndef ATP_REPORTS_FFM_FMWL
/* Late Detect Free Memory Write Reporting */
#define ATP_REPORTS_FFM_FMWL ATL_YES
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATP@ ATP_MAX_FREEQ_LENGTH <number>
#else
#ifndef ATP_MAX_FREEQ_LENGTH
/* Memory In Use Reporting */
#define ATP_MAX_FREEQ_LENGTH 100
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATP@ ATP_MAX_FREEQ_SIZE <number>
#else
#ifndef ATP_MAX_FREEQ_SIZE
/* Memory In Use Reporting */
#define ATP_MAX_FREEQ_SIZE 1000000
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATP@ ATP_REPORTS_ABWL ATL_YES|ATL_NO
#else
#ifndef ATP_REPORTS_ABWL
/* Late Detect Array Bounds Write Reporting */
#define ATP_REPORTS_ABWL ATL_YES
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATP@ ATP_RED_ZONE_SIZE <number>
#else
#ifndef ATP_RED_ZONE_SIZE
/* Memory In Use Reporting */
#define ATP_RED_ZONE_SIZE 16
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATP@ ATP_REPORTS_MIU ATL_YES|ATL_NO
#else
#ifndef ATP_REPORTS_MIU
/* Memory In Use Reporting */
#define ATP_REPORTS_MIU ATL_NO
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATP@ ATP_REPORTS_SIG ATL_YES|ATL_NO
#else
#ifndef ATP_REPORTS_SIG
/* Signal handled reporting */
#define ATP_REPORTS_SIG ATL_NO
#endif
#endif

#endif


/*******************************************************************************
* TestRT QuantifyLT:
*******************************************************************************/

#if USE_ATQ

#ifndef ATL_WITHOUT_STUDIO
@ATQ@ ATQ_COMPUTE_OVERHEAD ATL_YES|ATL_NO
#else
#ifndef ATQ_COMPUTE_OVERHEAD
/* computes overhead on measures due to its measurement */
#define ATQ_COMPUTE_OVERHEAD ATL_NO
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATQ@ ATQ_DUMP_DRIVER ATL_YES|ATL_NO
#else
#ifndef ATQ_DUMP_DRIVER
/* Dump Driver use */
#define ATQ_DUMP_DRIVER ATL_NO
#endif
#endif

#endif


/*******************************************************************************
* Several products settings:
*******************************************************************************/

#ifndef ATL_WITHOUT_STUDIO
@ATL@ ATL_MULTI_THREADS ATL_YES|ATL_NO
#else
#ifndef ATL_MULTI_THREADS
/*! Multi-threaded application */
#define ATL_MULTI_THREADS ATL_NO
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATL@ ATL_THREADS_MAX <number>
#else
#ifndef ATL_THREADS_MAX
/*! Threads table size */
#define ATL_THREADS_MAX 64
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATL@ ATL_BUFFER_SIZE <number>
#else
#ifndef ATL_BUFFER_SIZE
/*! I/O optimisation buffer size in bytes */
#define ATL_BUFFER_SIZE 16384
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATL@ ATL_NODE_NAME <string>
#else
#ifndef ATL_NODE_NAME
/*! Traces file name */
#define ATL_NODE_NAME ".root."
#endif
#endif

#ifndef ATL_WITHOUT_STUDIO
@ATL@ ATL_TRACES_FILE <string>
#else
#ifndef ATL_TRACES_FILE
/*! Traces file name */
#define ATL_TRACES_FILE "atl.out"
#endif
#endif

#define ATL_OS_CLOCK 1
#define ATL_PROCESS_CLOCK 2
#ifndef ATL_WITHOUT_STUDIO
@ATL@ ATL_CLOCK_KIND ATL_OS_CLOCK|ATL_PROCESS_CLOCK
#else
#ifndef ATL_CLOCK_KIND
/*! Clock type : OS or process */
#define ATL_CLOCK_KIND ATL_OS_CLOCK
#endif
#endif

